import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ProjectCollection, ProjectCollectionParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询我的收藏
 */
export async function pageProjectCollection(params: ProjectCollectionParam) {
  const res = await request.get<ApiResult<PageResult<ProjectCollection>>>(
    MODULES_API_URL + '/project/project-collection/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询我的收藏列表
 */
export async function listProjectCollection(params?: ProjectCollectionParam) {
  const res = await request.get<ApiResult<ProjectCollection[]>>(
    MODULES_API_URL + '/project/project-collection',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加我的收藏
 */
export async function addProjectCollection(data: ProjectCollection) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-collection',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改我的收藏
 */
export async function updateProjectCollection(data: ProjectCollection) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-collection',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除我的收藏
 */
export async function removeProjectCollection(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-collection/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除我的收藏
 */
export async function removeBatchProjectCollection(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-collection/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询我的收藏
 */
export async function getProjectCollection(appId: any) {
  const res = await request.get<ApiResult<ProjectCollection>>(
    MODULES_API_URL + '/project/project-collection/' + appId
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
